#ifndef JSUPPORT_H
#define JSUPPORT_H

/*
** our include(s)
*/

#define setjmp __stdargs setjmp
#define longjmp __stdargs longjmp
#include <setjmp.h>
#undef longjmp
#undef setjmp
//
#include "classbase.h"
//
#define JPEG_INTERNALS 42
#include "jinclude.h"
#include "jpeglib.h"
#include "jmemsys.h"
#include "jerror.h"

/*
** custom jpeg structures
*/

typedef struct {
  struct jpeg_error_mgr pub;
  jmp_buf               jmpbuf;
  long                  error, ignore;
} dt_error_mgr;

typedef struct {
  struct jpeg_source_mgr  pub;
  void                   *infile;
  JOCTET                 *buffer;
  boolean                 start_of_file;
} dt_src_mgr;

typedef struct {
  struct ClassBase  *cb;
  void              *pool;
  long               verbose;
  struct EasyStruct  es;
  void              *args;
} dt_client_mgr;

/*
** custom jpeg prototypes
*/

void jpeg_load_src(j_decompress_ptr,void *);
void jpeg_save_src(j_decompress_ptr,void *);

#if !defined(ALL_IN_ONE)

/*
** functions for asynchronous file I/O
*/

APTR OpenFFR(APTR,APTR,LONG,BPTR);
LONG FFRGetC(APTR);
LONG FFRRead(APTR,APTR,LONG);
LONG FFRWrite(APTR,APTR,LONG);
LONG CloseFFR(APTR);

/*
** functions for HAM encoding
*/

VOID CreateHAM6Line(UBYTE *,UBYTE *,UBYTE *,UBYTE *,LONG,ULONG);
VOID CreateHAM8Line(UBYTE *,UBYTE *,UBYTE *,UBYTE *,LONG,ULONG);

#endif

/*
** redirect library bases
*/

#define SysBase       cb->SysBase
#define DOSBase       cb->DOSBase
#define GfxBase       cb->GfxBase
#define UtilityBase   cb->UtilityBase
#define IntuitionBase cb->IntuitionBase
#define DataTypesBase cb->DataTypesBase
#define PictureClass  cb->PictureClass

#endif /* JSUPPORT_H */
